

template<class L,class A,L* ff(const basicAC_F0 & args)>
class CODE_L1 { public:
    typedef L* Result;
    typedef L* (*func)(const basicAC_F0 & args) ;
    static L* f(const basicAC_F0 & args) { return ff(args);} //  ff :A-> L*
    static ArrayOfaType  typeargs() {return ArrayOfaType(atype<A>);}
};

template<class L>
class CODE_L_Add { public:
    typedef const L* Result;
    static  E_F0 * f(const basicAC_F0 & args) {
        const L * a(dynamic_cast<const L*>((Expression) args[0]));
        const L * b(dynamic_cast<const L*>((Expression) args[1]));
        assert(a  && b );
        return new L(*a+*b);}
    static ArrayOfaType  typeargs() {return ArrayOfaType(atype<const L*>(),atype<const L*>());}
};
template<class L>
class CODE_L_Sub { public:
    typedef const L* Result;
    static  E_F0 * f(const basicAC_F0 & args) {
        const L * a(dynamic_cast<const L*>((Expression) args[0]));
        const L * b(dynamic_cast<const L*>((Expression) args[1]));
        assert(a  && b );
        L * bb = new L(*pminusOne * *b);
        return new L(*a+*bb);}
    static ArrayOfaType  typeargs() {return ArrayOfaType(atype<const L*>(),atype<const L*>());}
};

template<class L>
class CODE_L_Minus { public:
    typedef const L* Result;
    static  E_F0 * f(const basicAC_F0 & args) {
        const L * a(dynamic_cast<const L*>((Expression) args[0]));
        assert(a  && pminusOne );
        return new L(*pminusOne * *a);}
    static ArrayOfaType  typeargs() {return ArrayOfaType(atype<const L*>());}
};

template<class L,class A,class B>
class CODE_L_Mul { public:
    typedef const L* Result;
    static  E_F0 * f(const basicAC_F0 & args) {
        const A * a(dynamic_cast<const A*>((Expression) args[0]));
        const B * b(dynamic_cast<const B*>((Expression) args[1]));
        SHOWVERB(cout << " CODE_L_Mul " << a << " " << b << endl);
        assert(a  && b );
        return new L(*a * *b);}
    static ArrayOfaType  typeargs() {return ArrayOfaType(atype<const A*>(),atype<const B*>());}
};

template<class T,class L>
class CODE_L_MulRL { public:
    typedef const L* Result;
    static  E_F0 * f(const basicAC_F0 & args) {
        const L * b(dynamic_cast<const L*>((Expression) args[1]));
        assert( b );
        return new L(to<T>(args[0]) * *b);}
    static ArrayOfaType  typeargs() {return ArrayOfaType(atype<T>(),atype<const L*>());}
};

template<class L,class T>
class CODE_L_MulLR { public:
    typedef const L* Result;
    static  E_F0 * f(const basicAC_F0 & args) {
        const L * a(dynamic_cast<const L*>((Expression) args[0]));
        assert( a );
        return new L(to<T>(args[1]) * *a);}
    static ArrayOfaType  typeargs() {return ArrayOfaType(atype<Result>(),atype<T>());}
};

template<class L,class T>
class CODE_L_DivLR { public:
    typedef const L* Result;
    static  E_F0 * f(const basicAC_F0 & args) {
        const L * a(dynamic_cast<const L*>((Expression) args[0]));
        assert( a );
        return new L(C_F0(TheOperators,"/",*pOne,args[1]) * *a);}
    static ArrayOfaType  typeargs() {return ArrayOfaType(atype<Result>(),atype<T>());}
};

template<class L,operatortype op>
class CODE_Diff { public:
    typedef const L* Result;
    static  E_F0 * f(const basicAC_F0 & args) {
        const L * a=dynamic_cast<const L*>((Expression) args[0]) ;
        assert( a );
        return  Diff(a,op);}
    static ArrayOfaType  typeargs() {return ArrayOfaType(atype<Result>());}
};

