//Fichier Laplace.cpp modifie par Alain Perronnet
// a partir de l'original ecrit par Frederic HECHT  fem-v5/Laplace1.cpp
//------------------------------------------------------------------------------

//Resolution du Laplacien : Solution exacte U(x,y)=3*x+5*y

//------------------------------------------------------------------------------

int verbosity =2;        //Definit le niveau des impressions


#include <cmath>
#include <cstdlib>
#include <cassert>
#include <iostream>
#include <fstream>       //pour lire le fichier de maillage

#include "rgraph.hpp"    //pour les traces
using namespace std;  

#include "throwassert.hpp"
#include "Expression.hpp"
#include "MatriceCreuse_tpl.hpp"   //pour la matrice globale EF profil

using namespace Fem2D;

int main(int argc, char **argv)
{
  R2 h;
  Vertex vertices[8] = {
  };

  vertices[0].x = 0.; vertices[0].y = 0.;
  vertices[1].x = 3.; vertices[1].y = 0.;
  vertices[2].x = 1.; vertices[2].y = 2.;

// should fault :   Triangle tbad(vertices,0,1,3,2,0);
  Triangle t(vertices,0,1,2,0); // label=0; we dont care here


  cout << endl << "First exemple " <<endl;
  h = t.H(0); cout << "Hauteur 0 : " << h << endl;
  h = t.H(1); cout << "Hauteur 1 : " << h << endl;
  h = t.H(2); cout << "Hauteur 2 : " << h << endl;
  cout << "area      : " << t.area << endl;
  cout << "should be : 3" << endl << endl;
   
  return 0;
}
